#!/bin/bash
###########################################################################################
##      					Mundo Choc Cac
##  Author : 
##	Home Page 	: http://qt-project.org/wiki/Build_Qt5_mysql_plugin_for_Android
##  Author    	: Mynor Rene Choc Cac <mynorrene@choccac.com>
##	Home Page 	: http://www.mynorrene.choccac.com
##  Project   	: Driver Mysql
##  Date      	: 2015-06-08T16:06:39
##  License   	: GPL3 and Digia
##  Comment   	: none
##  Plataform 	: android_armv5, android_armv7 y android_x86.
##  FileName  	: libqsqlmysql.so
##  Dependency	: 	libmariadb.so
## 					liblog.so
##					libz.so
##					libdl.so
##					libstdc++.so
##					libm.so
##					libc.so
##  This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
##  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
## 
###########################################################################################
#http://qt-project.org/wiki/Build_Qt5_mysql_plugin_for_Android
here="$(readlink -e "$(dirname "$0")")"
echo ""
echo ""
echo "Adaptado por MundoChocCac"
echo "http://www.choccac.com"
echo ""
echo ""
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#================Configuracion del entorno============================
## Sdk Qt.
# Ruta de la carpeta ejemplo QTx.x.x/x.x
# path to folder the Qt example QTx.x.x/x.x
lugarSr="/home/"$USER"/Qt5.5.0/5.5"

## NDK Android
# ruta de la carpeta de android-ndk-r10X
# path to folder the android-ndk-r10X
miSdk="/home/"$USER"/Android/android-ndk-r10e"
# platforms = se esta usando android-13
# platforms = use android-13
miplafaforms="13"
# toolchains = actualmente Qt usa 4.9
# toolchains =  Qt use 4.9
mitoolchains="4.9"

## Src openSll, buscar la version en su pagina copiar el nombre y pegarlo.
## Src openSll, searh version home page, copy an paste name.
srcOpensll="openssl-1.0.1e"

## Src libiconv, buscar la version en su pagina copiar el nombre y pegarlo.
## Src libiconv,searh version home page, copy an paste name.
srcLibiconv="libiconv-1.14"

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

echo "1. android_armv5"
echo "2. android_armv7"
echo "3. android_x86"
printf "Driver Postgres: "
read miDriverCompi

xmipla=$(uname -m)

if [ $miDriverCompi = 1 ];
then
	echo "Compilando android_armv5"
	driverQT="android_armv5"
	arquitOpenSll="android"
	arquitlibiconv="arm"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-arm"
	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/arm-linux-androideabi-"
	fi

	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-x86/bin/arm-linux-androideabi-"
	fi
fi

if [ $miDriverCompi = 2 ];
then
	echo "Compilando android_armv7"
	driverQT="android_armv7"
	arquitOpenSll="android-armv7"
	arquitlibiconv="arm"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-arm"
	
	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/arm-linux-androideabi-"
	fi

	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-x86/bin/arm-linux-androideabi-"
	fi
fi

if [ $miDriverCompi = 3 ];
then
	echo "Compilando android_x86"
	driverQT="android_x86"
	arquitOpenSll="android-x86"
	##Verificar si  se puede ejecutar x86 o probar estos argumentos para host.
	# --host=x86
	# --host=i386 
	arquitlibiconv="arm"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-x86"
	
	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/x86-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/i686-linux-android-"
	fi

	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/x86-"$mitoolchains"/prebuilt/linux-x86/bin/i686-linux-android-"
	fi
fi

rm -R $PWD"/"$srcOpensll
rm -R $PWD"/"$srcLibiconv
rm -R $PWD"/mariadb-native-client"

find "$SR" > "$here/rootfs_files_before.txt" || exit 1
checkChanges() {
        find "$SR" > "$here/rootfs_files_after.txt" || exit 1
        echo "Cambios:"
        diff -u "$here/rootfs_files_before.txt" "$here/rootfs_files_after.txt"
}
trap checkChanges EXIT

# OpenSSL
miVerOpensll=$srcOpensll".tar.gz"
pkg=$miVerOpensll

dir=$(basename $pkg .tar.gz)

if [ ! -d $dir ]; then
        [ -f $pkg ] || wget http://www.openssl.org/source/$pkg
        tar -xf $pkg || exit 1
fi

pushd $dir
        RANLIB="$BR"ranlib CC="$BR"gcc ./Configure "$arquitOpenSll" --prefix=$SR/usr
        ANDROID_DEV=$SR/usr make #|| exit 1
        ANDROID_DEV=$SR/usr make || exit 1
        make install_sw || exit 1
popd

# libiconv
miVerLibiconv=$srcLibiconv".tar.gz"
pkg=$miVerLibiconv
dir=$(basename $pkg .tar.gz)

if [ ! -d $dir ]; then
        [ -f $pkg ] || wget http://ftp.gnu.org/pub/gnu/libiconv/$pkg
        tar -xf $pkg || exit 1
fi

pushd $dir
        STRIP="$BR"strip RANLIB="$BR"ranlib OBJDUMP="$BR"objdump AR="$BR"ar CC="$BR"gcc CFLAGS=--sysroot=$SR CPP="$BR"cpp CPPFLAGS=$CFLAGS ./configure --build=x86_64 --host="$arquitlibiconv" --prefix=$SR/usr --with-sysroot=$SR
        make || exit 1
        make install || exit 1
popd

# mariadbclient
if [ ! -d mariadb-native-client ]; then
        bzr branch lp:mariadb-native-client || exit 1
fi

pushd mariadb-native-client
        sed -i -e "s|ADD_SUBDIRECTORY(unittest/libmariadb)|#ADD_SUBDIRECTORY(unittest/libmariadb)|" CMakeLists.txt
        sed -i -e "N; s|typedef unsigned short ushort;\n#endif|#endif\ntypedef unsigned short ushort;|" include/my_global.h
        sed -i -e "N; s|SET_TARGET_PROPERTIES(libmariadb PROPERTIES VERSION.*||" libmariadb/CMakeLists.txt
        sed -i -e "N; s|SOVERSION \${CPACK_PACKAGE_VERSION_MAJOR})||" libmariadb/CMakeLists.txt # Pig disgusting: the previous multiline thingie should've done it
        sed -i -e "N; s|\${CPACK_PACKAGE_VERSION_MAJOR}||" libmariadb/CMakeLists.txt # Pig disgusting: what the fuck
        mkdir build
        pushd build
        PKG_CONFIG_PATH=$SR/usr/lib/pkgconfig cmake -DCMAKE_AR="$BR"ar -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_COMPILER="$BR"gcc -DCMAKE_C_FLAGS=--sysroot=$SR -DCMAKE_INSTALL_PREFIX=$SR/usr -DCMAKE_LINKER="$BR"ld -DCMAKE_NM="$BR"nm -DCMAKE_OBJCOPY="$BR"objcopy -DCMAKE_OBJDUMP="$BR"objdump -DCMAKE_RANLIB="$BR"ranlib -DCMAKE_STRIP="$BR"strip -DWITH_EXTERNAL_ZLIB=ON -DICONV_INCLUDE_DIR=$SR/usr/include -DICONV_LIBRARIES=$SR/usr/lib/libiconv.a -DZLIB_INCLUDE_DIR=$SR/usr/include -DZLIB_LIBRARY=$SR/usr/lib/libz.so ../ || exit 1
        make install || exit 1
        popd

        # ???
        pwd
        cp build/libmariadb/*.{a,so} "$SR/usr/lib/mariadb/" || exit 1
popd

lugar=$lugarSr"/Src/qtbase/src/plugins/sqldrivers/mysql"
lugar2=$lugarSr"/"$driverQT"/bin/qmake"
pushd $lugar
        qmake=$lugar2
        $qmake "INCLUDEPATH+=$SR/usr/include/mariadb" "LIBS+=$SR/usr/lib/mariadb/libmariadbclient.a $SR/usr/lib/libssl.a $SR/usr/lib/libcrypto.a $SR/usr/lib/libiconv.a" "LIBPATH+=$SR/usr/lib/mariadb" -o Makefile mysql.pro
        make || exit 1
        make install || exit 1
popd
echo ""
echo ""
echo "Dependecias necesarias par que se puede ejecutar el driver de postgres."
echo "esta deben incluirse manualmente desde QtCreator."
echo "->libmariadb.so"
echo "->libQt5Sql.so se incluye en el apk automaticamente"
echo "->libQt5Core.so se incluye en el apk automaticamente"
echo "->libgnustl_shared.so se incluye en el apk automaticamente"
echo "->liblog.so"
echo "->libz.so"
echo "->libdl.so"
echo "->libstdc++.so"
echo "->libm.so"
echo "->libc.so"
echo ""
echo ""
rm -R $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql"
mkdir $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/mysql/Makefile"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/mysql/.moc"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/mysql/.obj"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/mysql/.pch"
cp $PWD"/mariadb-native-client/build/libmariadb/libmariadb.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libmariadb.so"
cp $SR"/usr/lib/liblog.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/liblog.so"
cp $SR"/usr/lib/libz.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libz.so"
cp $SR"/usr/lib/libdl.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libdl.so"
cp $SR"/usr/lib/libstdc++.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libstdc++.so"
cp $SR"/usr/lib/libm.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libm.so"
cp $SR"/usr/lib/libc.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/mysql/libc.so"
echo ""
echo ""
echo "Adaptado por MundoChocCac"
echo "http://www.choccac.com"
echo ""
echo ""
echo "Terminado con exito."
